/*
line dancer

I have made this program before in qbasic, but the code was really sloppy, and some of the things
didn't really work, such as scoring in single player.

The game is basically a tron based thing. That is where i got the idea from in any case. Some people have said that it is like nibbles. Ya, i guess it is, but not too much. The whole idea is that it is good for learners, me learning c++.

Currently, I do not have high score saving implemented. 
made by Josiah Manson
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <allegro.h> //the graphics library i use for djgpp
#include <math.h>
#include <iostream.h>

#define MAX_SPEED	20
#define RES_X		320
#define RES_Y		240


//=============================================
//function declarations

void question(struct game_variables *g);
void game_variables_init(struct game_variables *g);
void player_variables_init(struct player_variables *p, struct game_variables *g);
void game_reset(BITMAP *buff, struct player_variables *p, struct game_variables *g);
void keyboard_input(struct player_variables *p, struct game_variables *g);
void increment_player(BITMAP *buff, struct player_variables *p, struct game_variables *g);
void draw_player(BITMAP *buff, struct player_variables *p, struct game_variables *g);
void map_create(BITMAP *buff, struct game_variables *g);
void draw_screen(BITMAP *buff);
void score(BITMAP *buff, struct player_variables *p, struct game_variables *g);

//=============================================
//structs

struct game_variables
{
	bool quit;
	bool reset;
	int res_x;
	int res_y;
	int obst_num;
	int obst_size;
	int obst_col;
	int play_num;
	int death_rad;
	int points;
};

struct player_variables
{
	bool ready;
	int dead;
	int color;
	int pos_x;
	int pos_y;
	int vel_x;
	int vel_y;
	int score;
};

//=============================================
//functions

void game_variables_init(game_variables *g)
{
	//things commented out are handled otherwise. these are defaults
	g->quit = 0;
	g->reset = 0;
	g->res_x = RES_X;
	g->res_y = RES_Y;
	//g->obst_num = 10; // represents the number within a 100x100 area
	//g->obst_size = 40;
	g->obst_col = 3; //cyan
	//g->play_num = 4;
	g->death_rad = 3;
	g->points = -1;
}

void player_variables_init(player_variables *p, game_variables *g)
{
	for (int i = 0; i < g->play_num; i++)
	{
		p[i].ready = 0;
		p[i].dead = 0;
		p[i].color = i + 1;
		p[i].pos_x = int(g->res_x * (i + 1) / (g->play_num + 1));
		p[i].pos_y = int(g->res_y / 2);
		p[i].vel_x = 0;
		p[i].vel_y = 0;
		p[i].score = 0;
	}

	p[0].color = 14; //yellow
	p[1].color = 2; //brown
	p[2].color = 1; //blue
	p[3].color = 6; //brown
}

// restarts game
void game_reset(BITMAP *buff, player_variables *p, game_variables *g)
{
	int score[4];
	for (int i = 0; i < 4; i++)
	{
		score[i] = p[i].score;
	}
	
	game_variables_init(g);
	player_variables_init(p, g);
	clear(buff);
	map_create(buff, g);

	for (int i = 0; i < 4; i++)
	{
		p[i].score = score[i];
	}
}

void keyboard_input(player_variables *p, game_variables *g)
{
	//general controlls
	if (key[KEY_ESC])
		g->quit = 1;
	
	//player 1
	if (key[KEY_UP] & KB_EXTENDED){
		p[0].vel_y = -1;
		p[0].vel_x = 0;
	}
	if (key[KEY_DOWN] & KB_EXTENDED){
		p[0].vel_y = 1;
		p[0].vel_x = 0;
	}
	if (key[KEY_LEFT] & KB_EXTENDED){
		p[0].vel_x = -1;
		p[0].vel_y = 0;
	}
	if (key[KEY_RIGHT] & KB_EXTENDED){
		p[0].vel_x = 1;
		p[0].vel_y = 0;
	}

	//player 2
	if (key[KEY_W]){
		p[1].vel_y = -1;
		p[1].vel_x = 0;
	}
	if (key[KEY_S]){
		p[1].vel_y = 1;
		p[1].vel_x = 0;
	}
	if (key[KEY_A]){
		p[1].vel_x = -1;
		p[1].vel_y = 0;
	}
	if (key[KEY_D]){
		p[1].vel_x = 1;
		p[1].vel_y = 0;
	}

	//player 3
	if (key[KEY_UP] & KB_NORMAL){
		p[2].vel_y = -1;
		p[2].vel_x = 0;
	}
	if (key[KEY_5_PAD] & KB_NORMAL){
		p[2].vel_y = 1;
		p[2].vel_x = 0;
	}
	if (key[KEY_LEFT] & KB_NORMAL){
		p[2].vel_x = -1;
		p[2].vel_y = 0;
	}
	if (key[KEY_RIGHT] & KB_NORMAL){
		p[2].vel_x = 1;
		p[2].vel_y = 0;
	}

	//player 4
	if (key[KEY_I]){
		p[3].vel_y = -1;
		p[3].vel_x = 0;
	}
	if (key[KEY_K]){
		p[3].vel_y = 1;
		p[3].vel_x = 0;
	}
	if (key[KEY_J]){
		p[3].vel_x = -1;
		p[3].vel_y = 0;
	}
	if (key[KEY_L]){
		p[3].vel_x = 1;
		p[3].vel_y = 0;
	}
}

// increments player, also does hit checking, and gives points to players
void increment_player(BITMAP *buff, player_variables *p, game_variables *g)
{
	int hit;
	int c = 0;

	for (int i = 0; i < g->play_num; i++)
	{
		if ((p[i].vel_x != 0) || (p[i].vel_y != 0)) // checks for readiness
			p[i].ready = 1;
		if (p[i].dead != 0)
			p[i].ready = 0;
		
		if ((p[i].ready == 1)){
			hit = getpixel(buff, p[i].pos_x + p[i].vel_x, p[i].pos_y + p[i].vel_y);

			if (hit != 0)
			{                            //determines order of death
				p[i].dead = 1;
				for (int j = 0; j < g->play_num; j++)
				{
					if (p[j].dead != 0)
						c++;
				}
				p[i].dead = g->play_num - c + 1;
				g->points = g->play_num - c;
				
			}
		}
				
		if (p[i].dead == 0){
			p[i].pos_x += p[i].vel_x;
			p[i].pos_y += p[i].vel_y;
		}
		else{
			p[i].vel_x = 0;
			p[i].vel_y = 0;
		}
	}
}

// draws players, and deaths
void draw_player(BITMAP *buff, player_variables *p, game_variables *g)
{
	for (int i = 0; i < g->play_num; i++)
	{
		if (p[i].dead == 0)
			putpixel(buff, p[i].pos_x, p[i].pos_y, p[i].color);
		else{
			circlefill(buff, p[i].pos_x, p[i].pos_y, g->death_rad, 4);
		}
	}
}

// draws the initial map
void map_create(BITMAP *buff, game_variables *g)
{
	int x[2], y[2]; //start and end positions
	int ox, oy; //offset
	int mx, my;
	int o; //temp obst num

	o = g->obst_num;

	mx = SCREEN_W / 100;
	o *= mx;
	my = SCREEN_H / 100;
	o *= my;


	rect(buff, 0, 0, SCREEN_W - 1, SCREEN_H - 1, g->obst_col);
	for (int i = 0; i < o; i++)
	{
		ox = (rand() % SCREEN_W);
		oy = (rand() % SCREEN_H);

		for (int j = 0; j < 2; j++)
		{
			x[j] = ox + (rand() % g->obst_size) - (g->obst_size / 2);
			y[j] = oy + (rand() % g->obst_size) - (g->obst_size / 2);
		}

		line(buff, x[0], y[0], x[1], y[1], g->obst_col);
	}
}

// just puts image on screen
void draw_screen(BITMAP *buff)
{
	rest(MAX_SPEED);
	vsync();
	blit(buff, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}

// scores stuff
void score(BITMAP *buff, player_variables *p, game_variables *g)
{
	char msg[80];

	int order[4][2];
	int temp;
	
	if (g->play_num == 1)
		p[0].score ++;

	if ((g->play_num == 1) && (p[0].dead))
	{
		draw_player(buff, p, g);
		draw_screen(buff);

		rest(500);

		clear(buff);
		sprintf(msg, "Good work! Your score is %d", p[0].score);
		textout(buff,font,msg,0,0,p[0].color);
		draw_screen(buff);

		while (!key[KEY_SPACE] && !key[KEY_ENTER] && !key[KEY_ESC])
		{
			rest(50);
		}

		g->reset = 1;
	}
	
	if ((g->points == 1) && (g->play_num > 1))
	{
		
		draw_player(buff, p, g);
		draw_screen(buff);
		
		for (int i = 0; i < 4; i ++)
		{
			if (p[i].dead == 0)
			{
				p[i].dead = g->points;
			}
			p[i].score += abs(p[i].dead - g->play_num); // this should do it //score has points from round added each time
		}
		
		
		rest(500);
		
		for (int i = 0; i < g->play_num; i++)
		{
			order[i][1] = i;
			order[i][0] = p[i].score;
		}
		
		for (int j = 0; j < g->play_num - 1; j++)
		{
			for (int i = 0; i < g->play_num - 1; i++)
			{
				if (order[i][0] < order[i + 1][0])
				{
				
					temp = order[i][0];
				
					order[i][0] = order[i + 1][0];
				
					order[i + 1][0] = temp;


					temp = order[i][1];
				
					order[i][1] = order[i + 1][1];
				
					order[i + 1][1] = temp;
			
				}
			}
		}

		clear(buff);

		for (int i = 0; i < g->play_num; i++)
		{
			sprintf(msg, "player %d has %d points", order[i][1] + 1, order[i][0]);
			textout(buff, font, msg, 0, 32 * i, p[order[i][1]].color);
		}

		draw_screen(buff);
		
		clear_keybuf();
		while (!key[KEY_SPACE] && !key[KEY_ENTER] && !key[KEY_ESC])
		{
			rest(50);
		}

		g->reset = 1;	
	}
}

void question(game_variables *g)
{
	int var, def;

	cout << "For help, press F1 during game.\n\n";

	cout << "How many players? (1-4) ";
	cin >> var;
	def = 1;
	if ((var > 4) || (var < 1))
		var = def;
	g->play_num = var;	
	
	cout << "How many obstacles per 100x100 area? (0-100) ";
	cin >> var;
	def = 10;
	if ((var > 100) || (var < 0))
		var = def;
	g->obst_num = var;

	cout << "What obstacle size? (0-100) ";
	cin >> var;
	def = 40;
	if ((var > 100) || (var < 0))
		var = def;
	g->obst_size = var;
}

//=============================================
//main function

int main()
{
	srand((unsigned)time(NULL));

	struct game_variables *g = new game_variables;
	game_variables_init(g);
	question(g);
	
	puts("\ncreating players");
	struct player_variables p[4];
	player_variables_init(p, g);

	puts("initializing display");
	allegro_init();
	install_timer();
	install_keyboard();
	clear_keybuf();

	set_color_depth(8);
	set_gfx_mode(GFX_AUTODETECT, g->res_x, g->res_y, 0, 0);
	
	puts("creating map");
	BITMAP *buff = create_bitmap(SCREEN_W, SCREEN_H);
	clear(buff);

	map_create(buff, g);

	puts("begin game");
	while(1)
	{
		increment_player(buff, p, g);
		draw_player(buff, p, g);
		score(buff, p, g);

		draw_screen(buff);

		keyboard_input(p, g);
		if (g->quit == 1)
			break;
		if (g->reset == 1)
			game_reset(buff, p, g);
	}
	
	//clean up after program
	destroy_bitmap(buff);
	clear_keybuf();
	return 0;
}
// END_OF_MAIN();
